### This is the system Rprofile file. It is always run on startup.
### Additional commands can be placed in site or user Rprofile files
#
#  Copyright (C) 1995-2012 The R Core Team
### (see ?Rprofile).

### Notice that it is a bad idea to use this file as a template for
### personal startup files, since things will be executed twice and in
### the wrong environment (user profiles are run in .GlobalEnv).

### This is the system Rprofile file. It is always run on startup.
### Additional commands can be placed in site or user Rprofile files
#
#  Copyright (C) 1995-2012 The R Core Team
### (see ?Rprofile).

### Notice that it is a bad idea to use this file as a template for
### personal startup files, since things will be executed twice and in
### the wrong environment (user profiles are run in .GlobalEnv).

### Mostly commented out as FastR currently does a lot of this in Java, which may change.

#.GlobalEnv <- globalenv()
attach(NULL, name = "Autoloads")
.AutoloadEnv <- as.environment(2)
assign(".Autoloaded", NULL, envir = .AutoloadEnv)
T <- TRUE
F <- FALSE
R.version <- structure(R.Version(), class = "simple.list")
version <- R.version            # for S compatibility

## for backwards compatibility only
R.version.string <- R.version$version.string
#
### NOTA BENE: options() for non-base package functionality are in places like
###            --------- ../utils/R/zzz.R
#
options(keep.source = interactive())
options(warn = 0)
# options(repos = c(CRAN="@CRAN@"))
# options(BIOC = "http://www.bioconductor.org")

options(timeout = 60)
options(encoding = "native.enc")
options(show.error.messages = TRUE)
## keep in sync with PrintDefaults() in  ../../main/print.c :
options(scipen = 0)
options(max.print = 99999)# max. #{entries} in internal printMatrix()
options(add.smooth = TRUE)# currently only used in 'plot.lm'
options(stringsAsFactors = TRUE)
if(!interactive() && is.null(getOption("showErrorCalls")))
    options(showErrorCalls = TRUE)

local({dp <- Sys.getenv("R_DEFAULT_PACKAGES")
       if(identical(dp, "")) # marginally faster to do methods last
           dp <- c("fastr", "datasets", "utils", "grDevices", "graphics",
                   "stats", "methods")
       else if(identical(dp, "NULL")) dp <- character(0)
       else dp <- strsplit(dp, ",")[[1]]
	   # There is a problem with the \\1
#       dp <- sub("[[:blank:]]*([[:alnum:]]+)", "\\1", dp) # strip whitespace
       options(defaultPackages = dp)
    })

## Expand R_LIBS_* environment variables.
Sys.setenv(R_LIBS_SITE =
           .expand_R_libs_env_var(Sys.getenv("R_LIBS_SITE")))
Sys.setenv(R_LIBS_USER =
           .expand_R_libs_env_var(Sys.getenv("R_LIBS_USER")))

.First.sys <- function()
{
    for(pkg in getOption("defaultPackages")) {
        res <- require(pkg, quietly = TRUE, warn.conflicts = FALSE,
                       character.only = TRUE)
        if(!res)
            warning(gettextf('package %s in options("defaultPackages") was not found', sQuote(pkg)),
                    call.=FALSE, domain = NA)
    }
}

.OptRequireMethods <- function()
{
      if("methods" %in% getOption("defaultPackages")) {
        res <- require("methods", quietly = TRUE, warn.conflicts = FALSE,
                       character.only = TRUE)
        if(!res)
            warning('package "methods" in options("defaultPackages") was not found', call.=FALSE)
    }
}

#if(nzchar(Sys.getenv("R_BATCH"))) {
#    .Last.sys <- function()
#    {
#        cat("> proc.time()\n")
#        print(proc.time())
#    }
#    ## avoid passing on to spawned R processes
#    ## A system has been reported without Sys.unsetenv, so try this
#    try(Sys.setenv(R_BATCH=""))
#}
####-*- R -*- Unix Specific ----

.Library <- file.path(R.home(), "library")
.Library.site <- Sys.getenv("R_LIBS_SITE")
.Library.site <- if(!nchar(.Library.site)) file.path(R.home(), "site-library") else unlist(strsplit(.Library.site, ":"))
.Library.site <- .Library.site[file.exists(.Library.site)]

invisible(.libPaths(c(unlist(strsplit(Sys.getenv("R_LIBS"), ":")),
                      unlist(strsplit(Sys.getenv("R_LIBS_USER"), ":")
                      ))))
local({
    popath <- Sys.getenv("R_TRANSLATIONS", "")
    if(!nzchar(popath)) {
        paths <- file.path(.libPaths(), "translations", "DESCRIPTION")
        popath <- dirname(paths[file.exists(paths)][1])
    } else {
    }
#    bindtextdomain("R", popath)
#    bindtextdomain("R-base", popath)
    assign(".popath", popath, .BaseNamespaceEnv)
})
#local({
### we distinguish between R_PAPERSIZE as set by the user and by configure
#papersize <- Sys.getenv("R_PAPERSIZE_USER")
#if(!nchar(papersize)) {
#    lcpaper <- Sys.getlocale("LC_PAPER") # might be null: OK as nchar is 0
#    papersize <- if(nchar(lcpaper))
#        if(length(grep("(_US|_CA)", lcpaper))) "letter" else "a4"
#    else Sys.getenv("R_PAPERSIZE")
#}
#options(papersize = papersize,
#        printcmd = Sys.getenv("R_PRINTCMD"),
#        dvipscmd = Sys.getenv("DVIPS", "dvips"),
#        texi2dvi = Sys.getenv("R_TEXI2DVICMD"),
#        browser = Sys.getenv("R_BROWSER"),
#        pager = file.path(R.home(), "bin", "pager"),
#        pdfviewer = Sys.getenv("R_PDFVIEWER"),
#        useFancyQuotes = TRUE)
#})
#
### non standard settings for the R.app GUI of the Mac OS X port
#if(.Platform$GUI == "AQUA") {
#    ## this is set to let RAqua use both X11 device and X11/TclTk
#    if (Sys.getenv("DISPLAY") == "")
#  Sys.setenv("DISPLAY" = ":0")
#
#    ## this is to allow gfortran compiler to work
#    Sys.setenv("PATH" = paste(Sys.getenv("PATH"),":/usr/local/bin",sep = ""))
#}## end "Aqua"
#
#local({
#    tests_startup <- Sys.getenv("R_TESTS")
#    if(nzchar(tests_startup)) source(tests_startup)
#})
